<script lang="ts">
	import type { HTMLInputAttributes } from 'svelte/elements';

	export let id: string;
	export let name: string;
	export let label: string;
	export let checked: boolean = false;
	export let rest: HTMLInputAttributes | null = null;
</script>

<div class="container">
	<label>
		<input type="checkbox" {name} {id} bind:checked {...rest} />
		<span class="checkmark" />
		{label}
	</label>
</div>

<style>
	/* Customize the label (the container) */
	.container {
		height: 36px;
		width: 100%;
		box-sizing: border-box;
		display: block;
		position: relative;
		padding-left: 35px;
		font-size: 22px;
		-webkit-user-select: none;
		-moz-user-select: none;
		-ms-user-select: none;
		user-select: none;
	}

	/* Style for the checkbox label */
	.container label {
		display: inline-block; /* Display the label as a block element */
		margin-left: 14px; /* Add margin on the left side for spacing */
		margin-top: 5px;
		font-size: 20px;
		cursor: pointer;
	}

	/* Hide the browser's default checkbox */
	.container input {
		position: absolute;
		opacity: 0;
		height: 0;
		width: 0;
	}

	/* Create a custom checkbox */
	.checkmark {
		position: absolute;
		top: 0;
		left: 0;
		height: 30px;
		width: 30px;
		background: linear-gradient(var(--manga-2), var(--manga-2)) padding-box,
			var(--border-color) border-box;
		border: 3px solid transparent;
		border-radius: 4px;
		cursor: pointer;
	}

	/* When the checkbox is checked, add gradient background */
	.container input:checked ~ .checkmark {
		background: var(--border-color) padding-box, var(--border-color) border-box;
	}

	/* Create the checkmark/indicator (hidden when not checked) */
	.checkmark:after {
		content: '';
		position: absolute;
		display: none;
	}

	/* Show the checkmark when checked */
	.container input:checked ~ .checkmark:after {
		display: block;
	}

	/* Style the checkmark/indicator */
	.container .checkmark:after {
		left: 9px;
		top: 0px;
		width: 10px;
		height: 20px;
		border: solid white;
		border-width: 0 3px 3px 0;
		-webkit-transform: rotate(45deg);
		-ms-transform: rotate(45deg);
		transform: rotate(45deg);
	}

	@media only screen and (max-width: 1120px) {
		.container {
			font-size: 12px;
		}
		.checkmark {
			width: 18px;
			height: 18px;
		}
		.container label {
			font-size: 12px;
			margin-left: 0px;
		}

		.container .checkmark:after {
			left: 4px;
			width: 5px;
			height: 10px;
		}
	}
</style>
